# normalize CRISPR log-transformed data by lowess regression
# Author: Han Xu
# Date: 09/26/2015
# Email: hanxu@broadinstitute.org

# using gct reader and writer
#source("common2.R")

#apply lowess regression to adjust values in vector y based on values in vector x, size is the number of samples for local regression
lowess.reg2 <- function(x,y,size)  {
  len <- length(x)
  
  if ((length(y)!=len)||(len<size))
  {
    return(NULL)
  }
  
#  old code with error in GP
#  df <- data.frame(index=(1:(len)), x=x,y=y)
#  df <- df[order(df$x), ]
#  fit = lowess(x,y,f = (as.double(size)/len), delta = 0.01*diff(range(x,na.rm=TRUE)))
#  df$fitted.y <- fit$y
#  df <- df[order(df$index), ]
#  return(df$y-df$fitted.y)

#  new code
   data.no.na <- na.omit(cbind(x,y))
   f <- approxfun(lowess(data.no.na[,1],data.no.na[,2], f=(as.double(size)/len)))
   return(y-f(x))
}
