## The Broad Institute
## SOFTWARE COPYRIGHT NOTICE AGREEMENT
## This software and its documentation are copyright (2013) by the
## Broad Institute/Massachusetts Institute of Technology. All rights are
## reserved.
##
## This software is supplied without any warranty or guaranteed support
## whatsoever. Neither the Broad Institute nor MIT can be responsible for its
## use, misuse, or functionality.

#performs PMAD, ZMAD or quantile normalization (method) on shRNA score file (gct.file).
#plots a before and after normalization (plotfile) 

 args <- commandArgs(trailingOnly=TRUE)

vers <- "2.15"            # R version
libdir <- args[1]
server.dir <- args[2]
patch.dir <- args[3]

source(file.path(libdir, "loadRLibrary.R"))

load.packages(libdir, patch.dir, server.dir, vers)

option_list <- list(
make_option("--gct.file", dest="gct.file"),
make_option("--method", dest="method"),
make_option("--plotfile", dest="plotfile")
 )

opt <- parse_args(OptionParser(option_list=option_list), positional_arguments=TRUE, args=args)
print(opt)
opts <- opt$options

source(file.path(libdir, "common2.R"))
source(file.path(libdir, "NormLines.R"))
source(file.path(libdir, "normalize.quantiles.with.NAs.R"))
source(file.path(libdir, "lowess.reg.R"))
source(file.path(libdir, "lowess.reg2.R"))
source(file.path(libdir, "Achilles_common.R"))
	sessionInfo()
	
	suppressMessages(library(RColorBrewer))
	suppressMessages(library(mnormt))
	suppressMessages(library(sn))
	
 un<-read.gct(opts$gct.file)
 n<-NormLines(data.matrix=un$data, method=opts$method, PDF.file=opts$plotfile)
 n<-round(n, digits=6) 
 x<-un
 x$data<-n
 x$rows<- rownames(n)
	colnames(x$data)<-colnames(un$data)
	print(opts$method)
	st<-strsplit(opts$gct.file,"/", fixed=TRUE)
	l<-length(st[[1]])
	print(l)
	basename<-st[[1]][l]
	print(basename) 

 rm(n)
 write.gct.nan(x,paste(opts$method, basename, sep='_'))

 in.gct = MSIG.Gct2Frame(opts$gct.file)  
 Module_Stats(in.gct,x)
 